import React from "react";
import { Registry } from "@nocobase/utils/client";
interface Calculator {
    name: string;
    type: 'boolean' | 'number' | 'string' | 'date' | 'unknown' | 'null' | 'array';
    group: string;
}
export declare const calculators: Registry<Calculator>;
export declare function parseValue(value: any, Types: any): {
    type: string;
    value?: any;
    options?: any;
};
export declare const BaseTypeSet: Set<string>;
export declare const VariableTypes: {
    constant: {
        title: string;
        value: string;
        options: {
            value: string;
            label: string;
        }[];
        component(props: any): any;
        appendTypeValue({ options }: {
            options?: {
                type: string;
            };
        }): string[];
        onTypeChange([type, optionsType]: [any, any], onChange: any): void;
        parse(path: any): {
            path: any;
        };
    };
    $jobsMapByNodeId: {
        title: string;
        value: string;
        options(): any[];
        component(props: any): React.ReactElement<any, string | React.JSXElementConstructor<any>>;
        appendTypeValue({ options }: {
            type: string;
            options: any;
        }): number[];
        onTypeChange([type, nodeId]: [any, any], onChange: any): void;
        parse([nodeId, ...path]: [any, ...any[]]): {
            nodeId: any;
            path: string;
        };
        stringify(next: any): string;
    };
    $context: {
        title: string;
        value: string;
        options(): {
            label: string;
            value: any;
            key: string;
        }[];
        component(props: any): React.ReactNode;
        appendTypeValue({ options }: {
            options: any;
        }): any[];
        onTypeChange([type, optionType]: [any, any], onChange: any): void;
        parse([type, ...path]: [any, ...any[]]): {
            path?: string;
            type: any;
        };
        stringify(next: any): string;
    };
};
export declare const VariableTypesContext: React.Context<{}>;
export declare function useVariableTypes(): {};
interface OperandProps {
    value: any;
    onChange(v: any): void;
    children?: React.ReactNode;
}
export declare function useOperandContext(): any;
export declare function Operand({ value, onChange, children }: OperandProps): JSX.Element;
export declare function Calculation({ calculator, operands, onChange }: {
    calculator: any;
    operands?: any[];
    onChange: any;
}): JSX.Element;
export declare function VariableComponent({ value, onChange, renderSchemaComponent }: {
    value: any;
    onChange: any;
    renderSchemaComponent: any;
}): JSX.Element;
export {};
