"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

function _react() {
  const data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _antd() {
  const data = require("antd");

  _antd = function _antd() {
    return data;
  };

  return data;
}

function _icons() {
  const data = require("@ant-design/icons");

  _icons = function _icons() {
    return data;
  };

  return data;
}

function _reactCopyToClipboard() {
  const data = require("react-copy-to-clipboard");

  _reactCopyToClipboard = function _reactCopyToClipboard() {
    return data;
  };

  return data;
}

var _calculators = require("../calculators");

var _FlowContext = require("../FlowContext");

function _client() {
  const data = require("@nocobase/client");

  _client = function _client() {
    return data;
  };

  return data;
}

var _locale = require("../locale");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function getVal(operand) {
  const _useWorkflowTranslati = (0, _locale.useWorkflowTranslation)(),
        t = _useWorkflowTranslati.t;

  const compile = (0, _client().useCompile)();

  const _useCollectionManager = (0, _client().useCollectionManager)(),
        getCollectionFields = _useCollectionManager.getCollectionFields;

  const _useFlowContext = (0, _FlowContext.useFlowContext)(),
        nodes = _useFlowContext.nodes;

  if (typeof operand === 'string') {
    let pathArr = operand.replace('{{', '').replace('}}', '').split('.');

    if (pathArr.length > 0) {
      const type = pathArr[0];

      if (type == '$context') {
        return `<%=${pathArr.map((value, index) => {
          if (index === 0) {
            return 'ctx';
          }

          return value;
        }).join('.')}%>`;
      }

      if (pathArr.length > 1 && type == '$jobsMapByNodeId') {
        const nodeId = pathArr[1];
        const node = nodes.find(n => n.id == nodeId);

        if (node) {
          var _node$config;

          if (node.type === 'calculation') {
            return `<%= node[${nodeId}] // ${t('Calculation result')} %>`;
          }

          if (pathArr.length > 2 && (node === null || node === void 0 ? void 0 : (_node$config = node.config) === null || _node$config === void 0 ? void 0 : _node$config.collection)) {
            var _node$config2;

            const fieldName = pathArr[2];
            const fields = getCollectionFields(node === null || node === void 0 ? void 0 : (_node$config2 = node.config) === null || _node$config2 === void 0 ? void 0 : _node$config2.collection);
            const field = fields.find(f => f.name == fieldName);

            if (field) {
              var _field$uiSchema;

              return `<%= node[${nodeId}].${fieldName} // ${compile(((_field$uiSchema = field.uiSchema) === null || _field$uiSchema === void 0 ? void 0 : _field$uiSchema.title) || field.name)} %>`;
            }

            return `<%= node[${nodeId}].${fieldName}%>`;
          }
        }
      }
    }
  }

  return '';
}

const AvailableVariableTool = props => {
  const _useWorkflowTranslati2 = (0, _locale.useWorkflowTranslation)(),
        t = _useWorkflowTranslati2.t;

  const _useState = (0, _react().useState)(''),
        _useState2 = _slicedToArray(_useState, 2),
        operand = _useState2[0],
        setOperand = _useState2[1];

  return _react().default.createElement(_antd().Row, {
    style: {
      width: '100%'
    }
  }, _react().default.createElement(_antd().Col, {
    span: 10
  }, _react().default.createElement(_calculators.Operand, {
    value: operand,
    onChange: v => setOperand(v)
  })), _react().default.createElement(_antd().Col, {
    span: 10
  }, _react().default.createElement(_antd().Input, {
    value: getVal(operand),
    disabled: true
  })), _react().default.createElement(_antd().Col, {
    span: 4
  }, _react().default.createElement(_reactCopyToClipboard().CopyToClipboard, {
    text: getVal(operand),
    onCopy: () => {
      _antd().message.success({
        content: t('Copy success!'),
        duration: 1,
        style: {
          marginTop: '20vh'
        }
      });
    }
  }, _react().default.createElement(_antd().Tooltip, {
    title: t('Copy variable output template statement')
  }, _react().default.createElement(_antd().Button, {
    icon: _react().default.createElement(_icons().CopyOutlined, null)
  })))));
};

function _default(props) {
  const _useState3 = (0, _react().useState)(false),
        _useState4 = _slicedToArray(_useState3, 2),
        showTool = _useState4[0],
        setShowTool = _useState4[1];

  const _useWorkflowTranslati3 = (0, _locale.useWorkflowTranslation)(),
        t = _useWorkflowTranslati3.t;

  const requestVariableTypes = {
    $context: _calculators.VariableTypes.$context,
    $jobsMapByNodeId: _calculators.VariableTypes.$jobsMapByNodeId
  };
  return _react().default.createElement(_calculators.VariableTypesContext.Provider, {
    value: requestVariableTypes
  }, _react().default.createElement(_antd().Row, {
    style: {
      width: '100%'
    }
  }, _react().default.createElement(_antd().Col, {
    span: 24
  }, _react().default.createElement(_antd().Tooltip, {
    title: t('Show available variable tool')
  }, _react().default.createElement(_antd().Button, {
    type: 'text',
    icon: _react().default.createElement(_icons().ToolOutlined, null),
    onClick: () => setShowTool(!showTool)
  })))), showTool && _react().default.createElement(AvailableVariableTool, null), _react().default.createElement(_antd().Row, {
    style: {
      width: '100%'
    }
  }, _react().default.createElement(_antd().Col, {
    span: 24
  }, _react().default.createElement(_antd().Input.TextArea, _objectSpread({}, props)))), showTool && _react().default.createElement(_antd().Row, null, _react().default.createElement(_antd().Col, {
    span: 24
  }, _react().default.createElement("div", {
    className: "ant-formily-item-extra"
  }, props.description, " ", t('Syntax see'), ' ', _react().default.createElement("a", {
    target: '_blank',
    href: 'https://ejs.co'
  }, "ejs"), ' '))));
}