"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.workflowSchema = void 0;

function _antd() {
  const data = require("antd");

  _antd = function _antd() {
    return data;
  };

  return data;
}

function _reactI18next() {
  const data = require("react-i18next");

  _reactI18next = function _reactI18next() {
    return data;
  };

  return data;
}

function _client() {
  const data = require("@nocobase/client");

  _client = function _client() {
    return data;
  };

  return data;
}

var _locale = require("../locale");

var _triggers = require("../triggers");

var _executions = require("./executions");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

const collection = {
  name: 'workflows',
  fields: [{
    type: 'string',
    name: 'title',
    interface: 'input',
    uiSchema: {
      title: '{{t("Name")}}',
      type: 'string',
      'x-component': 'Input',
      required: true
    }
  }, {
    type: 'string',
    name: 'type',
    interface: 'select',
    uiSchema: {
      title: `{{t("Trigger type", { ns: "${_locale.NAMESPACE}" })}}`,
      type: 'string',
      'x-component': 'Select',
      'x-decorator': 'FormItem',
      enum: Array.from(_triggers.triggers.getEntities()).map(([value, {
        title
      }]) => ({
        value,
        label: title,
        color: 'gold'
      })),
      required: true
    }
  }, {
    type: 'string',
    name: 'description',
    interface: 'textarea',
    uiSchema: {
      title: '{{t("Description")}}',
      type: 'string',
      'x-component': 'Input.TextArea'
    }
  }, {
    type: 'boolean',
    name: 'enabled',
    interface: 'radio',
    uiSchema: {
      title: `{{t("Status", { ns: "${_locale.NAMESPACE}" })}}`,
      type: 'string',
      enum: [{
        label: `{{t("On", { ns: "${_locale.NAMESPACE}" })}}`,
        value: true,
        color: '#52c41a'
      }, {
        label: `{{t("Off", { ns: "${_locale.NAMESPACE}" })}}`,
        value: false
      }],
      'x-component': 'Radio.Group',
      'x-decorator': 'FormItem',
      default: false
    }
  }, {
    type: 'number',
    name: 'allExecuted',
    interface: 'integer',
    uiSchema: {
      title: `{{t("Executed", { ns: "${_locale.NAMESPACE}" })}}`,
      type: 'number',
      'x-component': 'InputNumber',
      'x-decorator': 'FormItem'
    }
  }]
};
const workflowSchema = {
  type: 'void',
  properties: {
    provider: {
      type: 'void',
      'x-decorator': 'ResourceActionProvider',
      'x-decorator-props': {
        collection,
        resourceName: 'workflows',
        request: {
          resource: 'workflows',
          action: 'list',
          params: {
            pageSize: 20,
            filter: {
              current: true
            },
            sort: ['-enabled', '-createdAt'],
            except: ['config']
          }
        }
      },
      'x-component': 'CollectionProvider',
      'x-component-props': {
        collection
      },
      properties: {
        actions: {
          type: 'void',
          'x-component': 'ActionBar',
          'x-component-props': {
            style: {
              marginBottom: 16
            }
          },
          properties: {
            delete: {
              type: 'void',
              title: '{{t("Delete")}}',
              'x-component': 'Action',
              'x-component-props': {
                useAction: '{{ cm.useBulkDestroyAction }}',
                confirm: {
                  title: "{{t('Delete record')}}",
                  content: "{{t('Are you sure you want to delete it?')}}"
                }
              }
            },
            create: {
              type: 'void',
              title: '{{t("Add new")}}',
              'x-component': 'Action',
              'x-component-props': {
                type: 'primary'
              },
              properties: {
                drawer: {
                  type: 'void',
                  'x-component': 'Action.Drawer',
                  'x-decorator': 'Form',
                  'x-decorator-props': {
                    initialValue: {
                      current: true
                    }
                  },
                  title: '{{t("Add new")}}',
                  properties: {
                    title: {
                      'x-component': 'CollectionField',
                      'x-decorator': 'FormItem'
                    },
                    type: {
                      'x-component': 'CollectionField',
                      'x-decorator': 'FormItem'
                    },
                    description: {
                      'x-component': 'CollectionField',
                      'x-decorator': 'FormItem'
                    },
                    footer: {
                      type: 'void',
                      'x-component': 'Action.Drawer.Footer',
                      properties: {
                        cancel: {
                          title: '{{ t("Cancel") }}',
                          'x-component': 'Action',
                          'x-component-props': {
                            useAction: '{{ cm.useCancelAction }}'
                          }
                        },
                        submit: {
                          title: '{{ t("Submit") }}',
                          'x-component': 'Action',
                          'x-component-props': {
                            type: 'primary',
                            useAction: '{{ cm.useCreateAction }}'
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        table: {
          type: 'void',
          'x-component': 'Table.Void',
          'x-component-props': {
            rowKey: 'id',
            rowSelection: {
              type: 'checkbox'
            },
            useDataSource: '{{ cm.useDataSourceFromRAC }}'
          },
          properties: {
            title: {
              type: 'void',
              'x-decorator': 'Table.Column.Decorator',
              'x-component': 'Table.Column',
              properties: {
                title: {
                  type: 'string',
                  'x-component': 'CollectionField',
                  'x-read-pretty': true
                }
              }
            },
            type: {
              type: 'void',
              'x-decorator': 'Table.Column.Decorator',
              'x-component': 'Table.Column',
              properties: {
                type: {
                  type: 'string',
                  'x-component': 'CollectionField',
                  'x-read-pretty': true
                }
              }
            },
            enabled: {
              type: 'void',
              'x-decorator': 'Table.Column.Decorator',
              'x-component': 'Table.Column',
              properties: {
                enabled: {
                  type: 'boolean',
                  'x-component': 'CollectionField',
                  'x-read-pretty': true,
                  default: false
                }
              }
            },
            allExecuted: {
              type: 'void',
              'x-decorator': 'Table.Column.Decorator',
              'x-component': 'Table.Column',
              properties: {
                allExecuted: {
                  type: 'number',
                  'x-decorator': 'OpenDrawer',
                  'x-decorator-props': {
                    component: 'a'
                  },
                  'x-component': 'CollectionField',
                  'x-read-pretty': true,
                  properties: {
                    drawer: _executions.executionSchema
                  }
                }
              }
            },
            actions: {
              type: 'void',
              title: '{{ t("Actions") }}',
              'x-component': 'Table.Column',
              properties: {
                actions: {
                  type: 'void',
                  'x-component': 'Space',
                  'x-component-props': {
                    split: '|'
                  },
                  properties: {
                    config: {
                      type: 'void',
                      'x-component': 'WorkflowLink'
                    },
                    update: {
                      type: 'void',
                      title: '{{ t("Edit") }}',
                      'x-component': 'Action.Link',
                      'x-component-props': {
                        type: 'primary'
                      },
                      properties: {
                        modal: {
                          type: 'void',
                          'x-component': 'Action.Modal',
                          'x-decorator': 'Form',
                          'x-decorator-props': {
                            useValues: '{{ cm.useValuesFromRecord }}'
                          },
                          title: '{{ t("Edit") }}',
                          properties: {
                            title: {
                              'x-component': 'CollectionField',
                              'x-decorator': 'FormItem'
                            },
                            enabled: {
                              'x-component': 'CollectionField',
                              'x-decorator': 'FormItem'
                            },
                            description: {
                              'x-component': 'CollectionField',
                              'x-decorator': 'FormItem'
                            },
                            footer: {
                              type: 'void',
                              'x-component': 'Action.Modal.Footer',
                              properties: {
                                cancel: {
                                  title: '{{ t("Cancel") }}',
                                  'x-component': 'Action',
                                  'x-component-props': {
                                    useAction: '{{ cm.useCancelAction }}'
                                  }
                                },
                                submit: {
                                  title: '{{ t("Submit") }}',
                                  'x-component': 'Action',
                                  'x-component-props': {
                                    type: 'primary',
                                    useAction: '{{ cm.useUpdateAction }}'
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    revision: {
                      type: 'void',
                      title: `{{t("Duplicate", { ns: "${_locale.NAMESPACE}" })}}`,
                      'x-component': 'Action.Link',
                      'x-component-props': {
                        useAction() {
                          const _useTranslation = (0, _reactI18next().useTranslation)(),
                                t = _useTranslation.t;

                          const _useResourceActionCon = (0, _client().useResourceActionContext)(),
                                refresh = _useResourceActionCon.refresh;

                          const _useResourceContext = (0, _client().useResourceContext)(),
                                resource = _useResourceContext.resource,
                                targetKey = _useResourceContext.targetKey;

                          const _useRecord = (0, _client().useRecord)(),
                                filterByTk = _useRecord[targetKey];

                          return {
                            run() {
                              return _asyncToGenerator(function* () {
                                yield resource.revision({
                                  filterByTk
                                });

                                _antd().message.success(t('Operation succeeded'));

                                refresh();
                              })();
                            }

                          };
                        }

                      }
                    } // delete: {
                    //   type: 'void',
                    //   title: '{{ t("Delete") }}',
                    //   'x-component': 'Action.Link',
                    //   'x-component-props': {
                    //     confirm: {
                    //       title: "{{t('Delete record')}}",
                    //       content: "{{t('Are you sure you want to delete it?')}}",
                    //     },
                    //     useAction: '{{ cm.useDestroyActionAndRefreshCM }}',
                    //   },
                    // },

                  }
                }
              }
            }
          }
        }
      }
    }
  }
};
exports.workflowSchema = workflowSchema;